### Method

# EDataServer SourceCredentialsProvider ref_credentials_source

since: 3.16

#### Declaration [src]

    ESource*
    e_source_credentials_provider_ref_credentials_source (
      ESourceCredentialsProvider* provider,
      ESource* source
    )

#### Description [src]

Returns a referenced parent `ESource`, which holds the credentials for the given `source`. This is useful for collections, where the credentials are usually stored on the collection source, thus shared between child sources. When ther eis no such parent source, a `NULL` is returned, which means the `source` holds credentials for itself.

Available since: 3.16

#### Parameters

`source`

  Type: `ESource`

  An `ESource`.

  The data is owned by the caller of the method.

#### Return value

Type: `ESource`

Referenced parent `ESource`, which holds credentials, or `NULL`. Unref the returned non-NULL `ESource` with g_object_unref(), when no longer needed.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.